﻿using System;
using System.Collections.Generic;
using System.Runtime.ConstrainedExecution;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Threading;
using System.Windows.Forms;
using AddinExpress.MSO;
using AddinExpress.OL;
using Freshbooks.Library;
using Freshbooks.Library.Model;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace Freshbooks_Addin
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("7148F9BB-DDF3-4F43-894F-2405CD41D0A5"), ProgId("Freshbooks_Addin.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        private IRibbonUI theRibbonUI;

        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        #region UI Components

        private ImageList iml16x16Icons;
        private ADXOLSolutionModule freshbooksSolutionModule;
        private ADXRibbonTab adxFreshbooksRibbonTab;
        private ADXRibbonGroup adxRibbonGroup2;
        private ADXRibbonButton adxImportClientsRibbonButton;
        private ImageList iml32x32Icons;
        private ADXRibbonButton adxImportInvoicesRibbonButton;
        private ADXOlFormsManager freshbooksFormsManager;
        private ADXOlFormsCollectionItem adxOlFormsCollectionItem1;
        private ADXRibbonButton adxImportProjectsRibbonButton;
        private ADXRibbonTab contactInspector_ContactRibbonTab;
        private ADXRibbonTab contactInspector_InsertRibbonTab;
        private ADXRibbonTab contactInspector_FormatTextRibbonTab;
        private ADXRibbonTab contactInspector_DeveloperRibbonTab;
        private ADXRibbonTab contactInspector_ReviewRibbonTab;
        private ADXRibbonTab contactInspector_BackgroundRemovalRibbonTab;
        private ADXRibbonTab contactInspector_AddinsRibbonTab;
        private ADXOutlookAppEvents adxOutlookEvents;


        private ADXRibbonTab adxProjectsInspectorRibbonTab;
        private ADXRibbonGroup projectActionsRibbonGroup;
        private ADXRibbonButton saveProjectRibbonButton;
        private ADXRibbonButton deleteProjectRibbonButton;
        private ADXRibbonTab Explorer_SendReceiveRibbonTab;
        private ADXRibbonTab Explorer_FolderRibbonTab;
        private ADXRibbonTab Explorer_HomeRibbonTab;
        private ADXRibbonTab Explorer_JournalHomeRibbonTab;
        private ADXRibbonTab Explorer_TaskHomeRibbonTab;
        private ADXRibbonTab Explorer_AddinsRibbonTab;
        private ADXRibbonTab Explorer_ViewRibbonTab;
        private ADXRibbonTab Explorer_DeveloperRibbonTab;
        private ADXRibbonTab Explorer_MailHomeRibbonTab;
        private ADXRibbonTab adxFreshbooksProjectsExplorerRibbonTab;
        private ADXRibbonGroup adxRibbonGroup1;
        private ADXRibbonButton adxNewFreshbooksPorjectRibbonButton;
        private ADXRibbonGroup adxRibbonGroup3;
        private ADXRibbonButton adxDeleteFreshbooksProjectRibbonButton;
        private ADXRibbonGroup adxRibbonGroup4;
        private ADXRibbonButton adxImportFreshbooksProjectRibbonButton;

        #endregion

        private ADXOlFormsCollectionItem adxOlFormsCollectionItem2;


        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AddinModule));
            this.iml16x16Icons = new System.Windows.Forms.ImageList(this.components);
            this.freshbooksSolutionModule = new AddinExpress.MSO.ADXOLSolutionModule(this.components);
            this.adxFreshbooksRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup2 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.adxImportClientsRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.iml32x32Icons = new System.Windows.Forms.ImageList(this.components);
            this.adxImportInvoicesRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxImportProjectsRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.freshbooksFormsManager = new AddinExpress.OL.ADXOlFormsManager(this.components);
            this.adxOlFormsCollectionItem1 = new AddinExpress.OL.ADXOlFormsCollectionItem(this.components);
            this.adxOlFormsCollectionItem2 = new AddinExpress.OL.ADXOlFormsCollectionItem(this.components);
            this.contactInspector_ContactRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.contactInspector_InsertRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.contactInspector_FormatTextRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.contactInspector_DeveloperRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.contactInspector_ReviewRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.contactInspector_BackgroundRemovalRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.contactInspector_AddinsRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
            this.adxProjectsInspectorRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.projectActionsRibbonGroup = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.saveProjectRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.deleteProjectRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.Explorer_SendReceiveRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.Explorer_FolderRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.Explorer_HomeRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.Explorer_JournalHomeRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.Explorer_TaskHomeRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.Explorer_AddinsRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.Explorer_ViewRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.Explorer_DeveloperRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.Explorer_MailHomeRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxFreshbooksProjectsExplorerRibbonTab = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.adxNewFreshbooksPorjectRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxRibbonGroup3 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.adxDeleteFreshbooksProjectRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxRibbonGroup4 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.adxImportFreshbooksProjectRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            // 
            // iml16x16Icons
            // 
            this.iml16x16Icons.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("iml16x16Icons.ImageStream")));
            this.iml16x16Icons.TransparentColor = System.Drawing.Color.Transparent;
            this.iml16x16Icons.Images.SetKeyName(0, "freshbooks");
            this.iml16x16Icons.Images.SetKeyName(1, "clients");
            this.iml16x16Icons.Images.SetKeyName(2, "staff");
            this.iml16x16Icons.Images.SetKeyName(3, "invoice");
            this.iml16x16Icons.Images.SetKeyName(4, "project");
            this.iml16x16Icons.Images.SetKeyName(5, "task");
            this.iml16x16Icons.Images.SetKeyName(6, "timesheet");
            // 
            // adxFreshbooksRibbonTab
            // 
            this.adxFreshbooksRibbonTab.Caption = "Freshbooks";
            this.adxFreshbooksRibbonTab.Controls.Add(this.adxRibbonGroup2);
            this.adxFreshbooksRibbonTab.Id = "adxRibbonTab_b3e50cf211904199836f12db0951c596";
            this.adxFreshbooksRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxFreshbooksRibbonTab.Visible = false;
            // 
            // adxRibbonGroup2
            // 
            this.adxRibbonGroup2.Caption = "Import";
            this.adxRibbonGroup2.Controls.Add(this.adxImportClientsRibbonButton);
            this.adxRibbonGroup2.Controls.Add(this.adxImportInvoicesRibbonButton);
            this.adxRibbonGroup2.Controls.Add(this.adxImportProjectsRibbonButton);
            this.adxRibbonGroup2.Id = "adxRibbonGroup_5d4cf3ffbd794c2f8b6ae9bd51927e22";
            this.adxRibbonGroup2.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup2.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // adxImportClientsRibbonButton
            // 
            this.adxImportClientsRibbonButton.Caption = "Clients";
            this.adxImportClientsRibbonButton.Id = "adxRibbonButton_7dc53818484c41dcb1465e10c6f9272d";
            this.adxImportClientsRibbonButton.Image = 0;
            this.adxImportClientsRibbonButton.ImageList = this.iml32x32Icons;
            this.adxImportClientsRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxImportClientsRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxImportClientsRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            // 
            // iml32x32Icons
            // 
            this.iml32x32Icons.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("iml32x32Icons.ImageStream")));
            this.iml32x32Icons.TransparentColor = System.Drawing.Color.Transparent;
            this.iml32x32Icons.Images.SetKeyName(0, "clients");
            this.iml32x32Icons.Images.SetKeyName(1, "invoice");
            this.iml32x32Icons.Images.SetKeyName(2, "project");
            this.iml32x32Icons.Images.SetKeyName(3, "Delete");
            this.iml32x32Icons.Images.SetKeyName(4, "Save32.png");
            this.iml32x32Icons.Images.SetKeyName(5, "Import");
            // 
            // adxImportInvoicesRibbonButton
            // 
            this.adxImportInvoicesRibbonButton.Caption = "Invoices";
            this.adxImportInvoicesRibbonButton.Id = "adxRibbonButton_3496ddcc88454f778d4defee4b911e14";
            this.adxImportInvoicesRibbonButton.Image = 1;
            this.adxImportInvoicesRibbonButton.ImageList = this.iml32x32Icons;
            this.adxImportInvoicesRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxImportInvoicesRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxImportInvoicesRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.adxImportInvoicesRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxImportInvoicesRibbonButton_OnClick);
            // 
            // adxImportProjectsRibbonButton
            // 
            this.adxImportProjectsRibbonButton.Caption = "Projects";
            this.adxImportProjectsRibbonButton.Id = "adxRibbonButton_73b43aae006c424aaa3992b3ca754f39";
            this.adxImportProjectsRibbonButton.Image = 2;
            this.adxImportProjectsRibbonButton.ImageList = this.iml32x32Icons;
            this.adxImportProjectsRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxImportProjectsRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxImportProjectsRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.adxImportProjectsRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxImportProjectsRibbonButton_OnClick);
            // 
            // freshbooksFormsManager
            // 
            this.freshbooksFormsManager.Items.Add(this.adxOlFormsCollectionItem1);
            this.freshbooksFormsManager.Items.Add(this.adxOlFormsCollectionItem2);
            this.freshbooksFormsManager.SetOwner(this);
            // 
            // adxOlFormsCollectionItem1
            // 
            this.adxOlFormsCollectionItem1.FormClassName = "Freshbooks_Addin.frmInvoice";
            this.adxOlFormsCollectionItem1.InspectorItemTypes = AddinExpress.OL.ADXOlInspectorItemTypes.olJournal;
            this.adxOlFormsCollectionItem1.InspectorLayout = AddinExpress.OL.ADXOlInspectorLayout.CompleteReplacement;
            this.adxOlFormsCollectionItem1.InspectorMessageClass = "IPM.Journal.Freshbooks.Invoice";
            this.adxOlFormsCollectionItem1.UseOfficeThemeForBackground = true;
            // 
            // adxOlFormsCollectionItem2
            // 
            this.adxOlFormsCollectionItem2.FormClassName = "Freshbooks_Addin.frmProject";
            this.adxOlFormsCollectionItem2.InspectorItemTypes = AddinExpress.OL.ADXOlInspectorItemTypes.olContact;
            this.adxOlFormsCollectionItem2.InspectorLayout = AddinExpress.OL.ADXOlInspectorLayout.CompleteReplacement;
            this.adxOlFormsCollectionItem2.InspectorMessageClass = "IPM.Contact.Freshbooks.Project";
            this.adxOlFormsCollectionItem2.UseOfficeThemeForBackground = true;
            // 
            // contactInspector_ContactRibbonTab
            // 
            this.contactInspector_ContactRibbonTab.Caption = "Contact";
            this.contactInspector_ContactRibbonTab.Id = "contactInspector_ContactRibbonTab_eea98e2c4ad84d2a93a05c6f5c9170dd";
            this.contactInspector_ContactRibbonTab.IdMso = "TabContact";
            this.contactInspector_ContactRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookContact;
            // 
            // contactInspector_InsertRibbonTab
            // 
            this.contactInspector_InsertRibbonTab.Caption = "Insert";
            this.contactInspector_InsertRibbonTab.Id = "contactInspector_InsertRibbonTab_5aa0162c5a7c4c94b04e666fe7b6efa7";
            this.contactInspector_InsertRibbonTab.IdMso = "TabInsert";
            this.contactInspector_InsertRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookContact;
            // 
            // contactInspector_FormatTextRibbonTab
            // 
            this.contactInspector_FormatTextRibbonTab.Caption = "Format ";
            this.contactInspector_FormatTextRibbonTab.Id = "contactInspector_FormatTextRibbonTabb_e7b8bd77dd864d4ba50f40f17c3a0136";
            this.contactInspector_FormatTextRibbonTab.IdMso = "TabFormatText";
            this.contactInspector_FormatTextRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookContact;
            // 
            // contactInspector_DeveloperRibbonTab
            // 
            this.contactInspector_DeveloperRibbonTab.Caption = "Developer";
            this.contactInspector_DeveloperRibbonTab.Id = "contactInspector_DeveloperRibbonTab_db566a3b1760414a97bf6e4f8878b7e1";
            this.contactInspector_DeveloperRibbonTab.IdMso = "TabDeveloper";
            this.contactInspector_DeveloperRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookContact;
            // 
            // contactInspector_ReviewRibbonTab
            // 
            this.contactInspector_ReviewRibbonTab.Caption = "Review";
            this.contactInspector_ReviewRibbonTab.Id = "contactInspector_ReviewRibbonTab_f348065ef6b94f028cefb902ac5fa622";
            this.contactInspector_ReviewRibbonTab.IdMso = "TabReviewWord";
            this.contactInspector_ReviewRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookContact;
            // 
            // contactInspector_BackgroundRemovalRibbonTab
            // 
            this.contactInspector_BackgroundRemovalRibbonTab.Caption = "Background Removal";
            this.contactInspector_BackgroundRemovalRibbonTab.Id = "contactInspector_BackgroundRemovalRibbonTab_91b3a84c83174c2bb1df63c23827287b";
            this.contactInspector_BackgroundRemovalRibbonTab.IdMso = "TabBackgroundRemoval";
            this.contactInspector_BackgroundRemovalRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookContact;
            // 
            // contactInspector_AddinsRibbonTab
            // 
            this.contactInspector_AddinsRibbonTab.Caption = "Add-ins";
            this.contactInspector_AddinsRibbonTab.Id = "contactInspector_AddinsRibbonTab_e45f76267d5d411b8172788fed610b6a";
            this.contactInspector_AddinsRibbonTab.IdMso = "TabAddIns";
            this.contactInspector_AddinsRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookContact;
            // 
            // adxOutlookEvents
            // 
            this.adxOutlookEvents.InspectorActivate += new AddinExpress.MSO.ADXOlInspector_EventHandler(this.adxOutlookEvents_InspectorActivate);
            this.adxOutlookEvents.ExplorerFolderSwitch += new AddinExpress.MSO.ADXOlExplorer_EventHandler(this.adxOutlookEvents_ExplorerFolderSwitch);
            // 
            // adxProjectsInspectorRibbonTab
            // 
            this.adxProjectsInspectorRibbonTab.Caption = "PROJECT";
            this.adxProjectsInspectorRibbonTab.Controls.Add(this.projectActionsRibbonGroup);
            this.adxProjectsInspectorRibbonTab.Id = "adxRibbonTab_730f7b84fc87463a8a541e1d59b81ace";
            this.adxProjectsInspectorRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookContact;
            // 
            // projectActionsRibbonGroup
            // 
            this.projectActionsRibbonGroup.Caption = "Actions";
            this.projectActionsRibbonGroup.Controls.Add(this.saveProjectRibbonButton);
            this.projectActionsRibbonGroup.Controls.Add(this.deleteProjectRibbonButton);
            this.projectActionsRibbonGroup.Id = "adxRibbonGroup_7682e53c3bf74513a4f422c51985f334";
            this.projectActionsRibbonGroup.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.projectActionsRibbonGroup.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookContact;
            // 
            // saveProjectRibbonButton
            // 
            this.saveProjectRibbonButton.Caption = "Save && Close";
            this.saveProjectRibbonButton.Id = "adxRibbonButton_d9c63b7489bf45d1aa41219f5a34dee3";
            this.saveProjectRibbonButton.Image = 4;
            this.saveProjectRibbonButton.ImageList = this.iml32x32Icons;
            this.saveProjectRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.saveProjectRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookContact;
            this.saveProjectRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            // 
            // deleteProjectRibbonButton
            // 
            this.deleteProjectRibbonButton.Caption = "Delete";
            this.deleteProjectRibbonButton.Id = "adxRibbonButton_42ec564fac33484abafabc3050512cc8";
            this.deleteProjectRibbonButton.Image = 3;
            this.deleteProjectRibbonButton.ImageList = this.iml32x32Icons;
            this.deleteProjectRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.deleteProjectRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookContact;
            this.deleteProjectRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            // 
            // Explorer_SendReceiveRibbonTab
            // 
            this.Explorer_SendReceiveRibbonTab.Caption = "Send / Receive";
            this.Explorer_SendReceiveRibbonTab.Id = "Explorer_SendReceiveRibbonTab_1f502540e12347fca75243b1d110a47c";
            this.Explorer_SendReceiveRibbonTab.IdMso = "TabSendReceive";
            this.Explorer_SendReceiveRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // Explorer_FolderRibbonTab
            // 
            this.Explorer_FolderRibbonTab.Caption = "Folder";
            this.Explorer_FolderRibbonTab.Id = "Explorer_FolderRibbonTab_8073e13915c240d59a2390e9921ec3d5";
            this.Explorer_FolderRibbonTab.IdMso = "TabFolder";
            this.Explorer_FolderRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // Explorer_HomeRibbonTab
            // 
            this.Explorer_HomeRibbonTab.Caption = "Home";
            this.Explorer_HomeRibbonTab.Id = "Explorer_HomeRibbonTab_b1b0c24f21d64a2698833e0bdcd5f4f3";
            this.Explorer_HomeRibbonTab.IdMso = "TabContacts";
            this.Explorer_HomeRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.Explorer_HomeRibbonTab.Visible = false;
            // 
            // Explorer_JournalHomeRibbonTab
            // 
            this.Explorer_JournalHomeRibbonTab.Caption = "Home";
            this.Explorer_JournalHomeRibbonTab.Id = "Explorer_JournalHomeRibbonTab_8861973c638440adb2393ea91806bcf1";
            this.Explorer_JournalHomeRibbonTab.IdMso = "TabJournals";
            this.Explorer_JournalHomeRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // Explorer_TaskHomeRibbonTab
            // 
            this.Explorer_TaskHomeRibbonTab.Caption = "Home";
            this.Explorer_TaskHomeRibbonTab.Id = "Explorer_TaskHomeRibbonTab_b1b0c24f21d64a2698833e0bdcd5f4f3";
            this.Explorer_TaskHomeRibbonTab.IdMso = "TabTasks";
            this.Explorer_TaskHomeRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.Explorer_TaskHomeRibbonTab.Visible = false;
            // 
            // Explorer_AddinsRibbonTab
            // 
            this.Explorer_AddinsRibbonTab.Caption = "Add-ins";
            this.Explorer_AddinsRibbonTab.Id = "Explorer_AddinsRibbonTab_de8bf649786d4405983c130c527f1079";
            this.Explorer_AddinsRibbonTab.IdMso = "TabAddIns";
            this.Explorer_AddinsRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // Explorer_ViewRibbonTab
            // 
            this.Explorer_ViewRibbonTab.Caption = "View";
            this.Explorer_ViewRibbonTab.Id = "Explorer_ViewRibbonTab_b3538d30fb984f068d76a3d3c8435ea7";
            this.Explorer_ViewRibbonTab.IdMso = "TabView";
            this.Explorer_ViewRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // Explorer_DeveloperRibbonTab
            // 
            this.Explorer_DeveloperRibbonTab.Caption = "Developer";
            this.Explorer_DeveloperRibbonTab.Id = "Explorer_DeveloperRibbonTab_2a9ec8d1e6604b10acf62c20f1add267";
            this.Explorer_DeveloperRibbonTab.IdMso = "TabDeveloper";
            this.Explorer_DeveloperRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // Explorer_MailHomeRibbonTab
            // 
            this.Explorer_MailHomeRibbonTab.Caption = "Home";
            this.Explorer_MailHomeRibbonTab.Id = "Explorer_HomeRibbonTab_b1b0c24f21d64a2698833e0bdcd5f4f3";
            this.Explorer_MailHomeRibbonTab.IdMso = "TabMail";
            this.Explorer_MailHomeRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.Explorer_MailHomeRibbonTab.Visible = false;
            // 
            // adxFreshbooksProjectsExplorerRibbonTab
            // 
            this.adxFreshbooksProjectsExplorerRibbonTab.Caption = "PROJECTS";
            this.adxFreshbooksProjectsExplorerRibbonTab.Controls.Add(this.adxRibbonGroup1);
            this.adxFreshbooksProjectsExplorerRibbonTab.Controls.Add(this.adxRibbonGroup3);
            this.adxFreshbooksProjectsExplorerRibbonTab.Controls.Add(this.adxRibbonGroup4);
            this.adxFreshbooksProjectsExplorerRibbonTab.Id = "adxRibbonTab_426e512e232d430e8ea4e6670391a661";
            this.adxFreshbooksProjectsExplorerRibbonTab.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxFreshbooksProjectsExplorerRibbonTab.Visible = false;
            // 
            // adxRibbonGroup1
            // 
            this.adxRibbonGroup1.Caption = "New";
            this.adxRibbonGroup1.Controls.Add(this.adxNewFreshbooksPorjectRibbonButton);
            this.adxRibbonGroup1.Id = "adxRibbonGroup_f9317ae381ce438ab9a97f9b347a7d76";
            this.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // adxNewFreshbooksPorjectRibbonButton
            // 
            this.adxNewFreshbooksPorjectRibbonButton.Caption = "New Freshbooks Project";
            this.adxNewFreshbooksPorjectRibbonButton.Id = "adxRibbonButton_4cb931100eda4c18954830c7ae81e6a2";
            this.adxNewFreshbooksPorjectRibbonButton.Image = 2;
            this.adxNewFreshbooksPorjectRibbonButton.ImageList = this.iml32x32Icons;
            this.adxNewFreshbooksPorjectRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxNewFreshbooksPorjectRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxNewFreshbooksPorjectRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.adxNewFreshbooksPorjectRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxNewFreshbooksPorjectRibbonButton_OnClick);
            // 
            // adxRibbonGroup3
            // 
            this.adxRibbonGroup3.Caption = "Delete";
            this.adxRibbonGroup3.Controls.Add(this.adxDeleteFreshbooksProjectRibbonButton);
            this.adxRibbonGroup3.Id = "adxRibbonGroup_2bea558ff879445899b4cf2eee7322dd";
            this.adxRibbonGroup3.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup3.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // adxDeleteFreshbooksProjectRibbonButton
            // 
            this.adxDeleteFreshbooksProjectRibbonButton.Caption = "Delete";
            this.adxDeleteFreshbooksProjectRibbonButton.Id = "adxRibbonButton_0f5e562ce3464a3bbddc03d48c861d1f";
            this.adxDeleteFreshbooksProjectRibbonButton.Image = 3;
            this.adxDeleteFreshbooksProjectRibbonButton.ImageList = this.iml32x32Icons;
            this.adxDeleteFreshbooksProjectRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxDeleteFreshbooksProjectRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxDeleteFreshbooksProjectRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            // 
            // adxRibbonGroup4
            // 
            this.adxRibbonGroup4.Caption = "Import";
            this.adxRibbonGroup4.Controls.Add(this.adxImportFreshbooksProjectRibbonButton);
            this.adxRibbonGroup4.Id = "adxRibbonGroup_56a9407009624774837449675a238b4a";
            this.adxRibbonGroup4.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup4.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // adxImportFreshbooksProjectRibbonButton
            // 
            this.adxImportFreshbooksProjectRibbonButton.Caption = "Import";
            this.adxImportFreshbooksProjectRibbonButton.Id = "adxRibbonButton_dd138bb02598465ba78d526c0607aa9f";
            this.adxImportFreshbooksProjectRibbonButton.Image = 5;
            this.adxImportFreshbooksProjectRibbonButton.ImageList = this.iml32x32Icons;
            this.adxImportFreshbooksProjectRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxImportFreshbooksProjectRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxImportFreshbooksProjectRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.adxImportFreshbooksProjectRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxImportFreshbooksProjectRibbonButton_OnClick);
            // 
            // AddinModule
            // 
            this.AddinName = "Freshbooks_Addin";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
            this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);
            this.OnRibbonLoaded += new AddinExpress.MSO.ADXRibbonLoaded_EventHandler(this.AddinModule_OnRibbonLoaded);

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private void AddinModule_AddinStartupComplete(object sender, EventArgs e)
        {
            Outlook._NameSpace session = OutlookApp.GetNamespace("MAPI");
            Outlook._Store defaultStore = session.DefaultStore;
            Outlook.Folder rootFolder = defaultStore.GetRootFolder() as Outlook.Folder;
            Outlook.Folder freshbooksFolder = freshbooksFolder = GetFolder(rootFolder.FolderPath + @"\Freshbooks");
            if (freshbooksFolder != null)
                freshbooksFolder.Delete();

            if (freshbooksFolder != null) Marshal.ReleaseComObject(freshbooksFolder);
            if (rootFolder != null) Marshal.ReleaseComObject(rootFolder);
            if (defaultStore != null) Marshal.ReleaseComObject(defaultStore);
            if (session != null) Marshal.ReleaseComObject(session);

            CreateFreshbooksFolders();
            CreateSolutionModuleLayout();
        }

        private void CreateFreshbooksFolders()
        {
            Outlook._NameSpace session = null;
            Outlook._Store defaultStore = null;
            Outlook.Folder rootFolder = null;

            Outlook.Folder freshbooksFolder = null;
            Outlook.Folders rootFolders = null;

            try
            {
                session = OutlookApp.GetNamespace("MAPI");
                defaultStore = session.DefaultStore;
                rootFolder = defaultStore.GetRootFolder() as Outlook.Folder;

                freshbooksFolder = GetFolder(rootFolder.FolderPath + @"\Freshbooks");
                if (freshbooksFolder == null)
                {
                    rootFolders = rootFolder.Folders;
                    freshbooksFolder = rootFolders.Add("Freshbooks", Outlook.OlDefaultFolders.olFolderInbox) as Outlook.Folder;

                    CreateFolder(freshbooksFolder, "Clients", Outlook.OlDefaultFolders.olFolderContacts, "IPM.Contact.Freshbooks.Client", "Client", true);
                    CreateClientView(GetFolder(freshbooksFolder.FolderPath + "\\Clients"));

                    CreateFolder(freshbooksFolder, "Invoices", Outlook.OlDefaultFolders.olFolderJournal, "IPM.Journal.Freshbooks.Invoice", "Invoice");
                    AddInvoiceFields(GetFolder(freshbooksFolder.FolderPath + "\\Invoices"));
                    CreateInvoiceView(GetFolder(freshbooksFolder.FolderPath + "\\Invoices"));

                    CreateFolder(freshbooksFolder, "Staff", Outlook.OlDefaultFolders.olFolderContacts, "IPM.Contact.Freshbooks.Staff", "Team Member", true);
                    CreateFolder(freshbooksFolder, "Projects", Outlook.OlDefaultFolders.olFolderContacts, "IPM.Contact.Freshbooks.Project", "Project", true);
                    AddProjectFields(GetFolder(freshbooksFolder.FolderPath + "\\Projects"));
                    CreateProjectView(GetFolder(freshbooksFolder.FolderPath + "\\Projects"));

                    CreateFolder(freshbooksFolder, "Tasks", Outlook.OlDefaultFolders.olFolderTasks, "IPM.Task.Freshbooks.Task", "Task");
                    CreateFolder(freshbooksFolder, "Timesheets", Outlook.OlDefaultFolders.olFolderCalendar, "IPM.Appointment.Freshbooks.Timesheet", "Timesheet");
                }
            }
            finally
            {
                if (rootFolders != null) Marshal.ReleaseComObject(rootFolders);
                if (freshbooksFolder != null) Marshal.ReleaseComObject(freshbooksFolder);
                if (rootFolder != null) Marshal.ReleaseComObject(rootFolder);
                if (defaultStore != null) Marshal.ReleaseComObject(defaultStore);
                if (session != null) Marshal.ReleaseComObject(session);
            }
        }

        private void CreateSolutionModuleLayout()
        {
            ADXOLSolutionFolder freshbooksFolder = new ADXOLSolutionFolder
            {
                FolderName = "Freshbooks",
                FolderType = ADXOLSolutionFolderType.Inbox,
                ImageList = iml16x16Icons,
                Image = 0
            };

            ADXOLSolutionFolder freshbooksClientsFolder = new ADXOLSolutionFolder
            {
                FolderName = "Clients",
                FolderType = ADXOLSolutionFolderType.Contacts,
                ImageTransparentColor = System.Drawing.Color.Transparent,
                ImageList = iml16x16Icons,
                Image = 1
            };

            ADXOLSolutionFolder freshbooksStaffFolder = new ADXOLSolutionFolder
            {
                FolderName = "Staff",
                FolderType = ADXOLSolutionFolderType.Contacts,
                ImageTransparentColor = System.Drawing.Color.Transparent,
                ImageList = iml16x16Icons,
                Image = 2
            };

            ADXOLSolutionFolder freshbooksInvoiceFolder = new ADXOLSolutionFolder
            {
                FolderName = "Invoices",
                FolderType = ADXOLSolutionFolderType.Journal,
                ImageTransparentColor = System.Drawing.Color.Transparent,
                ImageList = iml16x16Icons,
                Image = 3
            };

            ADXOLSolutionFolder freshbooksProjectsFolder = new ADXOLSolutionFolder
            {
                FolderName = "Projects",
                FolderType = ADXOLSolutionFolderType.Contacts,
                ImageTransparentColor = System.Drawing.Color.Transparent,
                ImageList = iml16x16Icons,
                Image = 4
            };

            ADXOLSolutionFolder freshbooksTasksFolder = new ADXOLSolutionFolder
            {
                FolderName = "Tasks",
                FolderType = ADXOLSolutionFolderType.Tasks,
                ImageTransparentColor = System.Drawing.Color.Transparent,
                ImageList = iml16x16Icons,
                Image = 5
            };

            ADXOLSolutionFolder freshbooksTimesheetsFolder = new ADXOLSolutionFolder
            {
                FolderName = "Timesheets",
                FolderType = ADXOLSolutionFolderType.Calendar,
                ImageTransparentColor = System.Drawing.Color.Transparent,
                ImageList = iml16x16Icons,
                Image = 6
            };

            freshbooksFolder.Folders.Add(freshbooksClientsFolder);
            freshbooksFolder.Folders.Add(freshbooksStaffFolder);
            freshbooksFolder.Folders.Add(freshbooksInvoiceFolder);
            freshbooksFolder.Folders.Add(freshbooksProjectsFolder);
            freshbooksFolder.Folders.Add(freshbooksTasksFolder);
            freshbooksFolder.Folders.Add(freshbooksTimesheetsFolder);
            freshbooksSolutionModule.Folders.Add(freshbooksFolder);
        }

        //http://www.add-in-express.com/creating-addins-blog/2012/04/09/customize-outlook-views-programmatically/
        private void CreateClientView(Outlook.Folder folder)
        {
            Outlook._Views folderViews = null;
            Outlook._TableView tableView = null;
            Outlook._ViewFields viewFields = null;

            Outlook._ViewField firstNameField = null;
            Outlook._ColumnFormat firstNameFieldFormat = null;
            //Outlook._ViewField lastNameField = null;
            //Outlook._ColumnFormat lastNameFieldFormat = null;
            //Outlook._ViewField workPhoneField = null;
            //Outlook._ColumnFormat workPhoneFieldFormat = null;

            try
            {
                folderViews = folder.Views;
                tableView = folderViews.Add("Freshbooks Clients", Outlook.OlViewType.olTableView, Outlook.OlViewSaveOption.olViewSaveOptionThisFolderEveryone) as Outlook._TableView;
                tableView.XML = Properties.Settings.Default.EmptyViewXml;
                tableView.ShowNewItemRow = false;
                tableView.AutomaticColumnSizing = true;
                tableView.AllowInCellEditing = false;

                viewFields = tableView.ViewFields;
                //// First Name
                //firstNameField = viewFields["urn:schemas:contacts:cn"];
                //firstNameFieldFormat = firstNameField.ColumnFormat;
                //firstNameFieldFormat.Label = "First Name";
                //// Last Name
                //lastNameField = viewFields["urn:schemas:contacts:sn"];
                //lastNameFieldFormat = lastNameField.ColumnFormat;
                //lastNameFieldFormat.Label = "Last Name";
                //// Work Phone
                //workPhoneField = viewFields["urn:schemas:contacts:office2telephonenumber"];
                //workPhoneFieldFormat = workPhoneField.ColumnFormat;
                //workPhoneFieldFormat.Label = "Work Phone";

                tableView.Save();
                tableView.Apply();
            }
            finally
            {
                if (firstNameFieldFormat != null) Marshal.ReleaseComObject(firstNameFieldFormat);
                if (firstNameField != null) Marshal.ReleaseComObject(firstNameField);
                if (viewFields != null) Marshal.ReleaseComObject(viewFields);
                if (tableView != null) Marshal.ReleaseComObject(tableView);
                if (folderViews != null) Marshal.ReleaseComObject(folderViews);
            }
        }

        private void AddProjectFields(Outlook.Folder folder)
        {
            AddPropertyToFolder(folder, "fb-description", Outlook.OlUserPropertyType.olText);
            AddPropertyToFolder(folder, "fb-rate", Outlook.OlUserPropertyType.olCurrency);
            AddPropertyToFolder(folder, "fb-hourbudget", Outlook.OlUserPropertyType.olCurrency);
            AddPropertyToFolder(folder, "fb-billmethod", Outlook.OlUserPropertyType.olText);
        }

        private void CreateProjectView(Outlook.Folder folder)
        {
            Outlook._Views folderViews = null;
            Outlook._TableView tableView = null;
            Outlook._ViewFields viewFields = null;

            Outlook._ViewField nameField = null;
            Outlook._ColumnFormat nameFieldFormat = null;

            Outlook._ViewField descriptionField = null;
            Outlook._ColumnFormat descriptionFieldFormat = null;

            Outlook._ViewField rateField = null;
            Outlook._ColumnFormat rateFieldFormat = null;

            Outlook._ViewField budgetField = null;
            Outlook._ColumnFormat budgetFieldFormat = null;

            Outlook._ViewField billMethodField = null;
            Outlook._ColumnFormat billMethodFieldFormat = null;

            try
            {
                folderViews = folder.Views;
                tableView = folderViews.Add("Freshbooks Projects", Outlook.OlViewType.olTableView, Outlook.OlViewSaveOption.olViewSaveOptionThisFolderEveryone) as Outlook._TableView;
                tableView.XML = Properties.Settings.Default.EmptyViewXml;
                tableView.ShowNewItemRow = false;
                tableView.AutomaticColumnSizing = true;
                tableView.AllowInCellEditing = false;

                viewFields = tableView.ViewFields;
                //  Name
                nameField = viewFields["urn:schemas:contacts:cn"];
                nameFieldFormat = nameField.ColumnFormat;
                nameFieldFormat.Label = "Project Name";
                // Description
                descriptionField = viewFields.Add("fb-description");
                descriptionFieldFormat = descriptionField.ColumnFormat;
                descriptionFieldFormat.Label = "Description";
                // Rate
                rateField = viewFields.Add("fb-rate");
                rateFieldFormat = rateField.ColumnFormat;
                rateFieldFormat.Label = "Rate";
                // Budget
                budgetField = viewFields.Add("fb-hourbudget");
                budgetFieldFormat = budgetField.ColumnFormat;
                budgetFieldFormat.Label = "Budget";
                // Budget
                billMethodField = viewFields.Add("fb-billmethod");
                billMethodFieldFormat = billMethodField.ColumnFormat;
                billMethodFieldFormat.Label = "Billing Method";

                tableView.Save();
                tableView.Apply();
            }
            finally
            {
                if (billMethodFieldFormat != null) Marshal.ReleaseComObject(billMethodFieldFormat);
                if (billMethodField != null) Marshal.ReleaseComObject(billMethodField);
                if (budgetFieldFormat != null) Marshal.ReleaseComObject(budgetFieldFormat);
                if (budgetField != null) Marshal.ReleaseComObject(budgetField);
                if (rateFieldFormat != null) Marshal.ReleaseComObject(rateFieldFormat);
                if (rateField != null) Marshal.ReleaseComObject(rateField);
                if (descriptionFieldFormat != null) Marshal.ReleaseComObject(descriptionFieldFormat);
                if (descriptionField != null) Marshal.ReleaseComObject(descriptionField);
                if (nameFieldFormat != null) Marshal.ReleaseComObject(nameFieldFormat);
                if (nameField != null) Marshal.ReleaseComObject(nameField);
                if (viewFields != null) Marshal.ReleaseComObject(viewFields);
                if (tableView != null) Marshal.ReleaseComObject(tableView);
                if (folderViews != null) Marshal.ReleaseComObject(folderViews);
            }
        }

        private void AddInvoiceFields(Outlook.Folder folder)
        {
            AddPropertyToFolder(folder, "fb-clientid", Outlook.OlUserPropertyType.olNumber);
            AddPropertyToFolder(folder, "fb-invoicenumber", Outlook.OlUserPropertyType.olText);
            AddPropertyToFolder(folder, "fb-clientname", Outlook.OlUserPropertyType.olText);
            AddPropertyToFolder(folder, "fb-status", Outlook.OlUserPropertyType.olText);
            AddPropertyToFolder(folder, "fb-date", Outlook.OlUserPropertyType.olDateTime);
            AddPropertyToFolder(folder, "fb-ponumber", Outlook.OlUserPropertyType.olText);
            AddPropertyToFolder(folder, "fb-amount", Outlook.OlUserPropertyType.olCurrency);
            AddPropertyToFolder(folder, "fb-linesXML", Outlook.OlUserPropertyType.olText);
        }

        private void CreateInvoiceView(Outlook.Folder folder)
        {
            Outlook._Views folderViews = null;
            Outlook._TableView tableView = null;
            Outlook._ViewFields viewFields = null;

            Outlook._ViewField clientIdField = null;
            Outlook._ColumnFormat clientIdFieldFormat = null;

            Outlook._ViewField invoiceNumberField = null;
            Outlook._ColumnFormat invoiceNumberFieldFormat = null;

            Outlook._ViewField statusField = null;
            Outlook._ColumnFormat statusFieldFormat = null;

            Outlook._ViewField dateField = null;
            Outlook._ColumnFormat dateFieldFormat = null;

            Outlook._ViewField poNumberField = null;
            Outlook._ColumnFormat poNumberFieldFormat = null;

            Outlook._ViewField termsField = null;
            Outlook._ColumnFormat termsFieldFormat = null;

            try
            {
                folderViews = folder.Views;
                tableView = folderViews.Add("Freshbooks Invoices", Outlook.OlViewType.olTableView, Outlook.OlViewSaveOption.olViewSaveOptionThisFolderEveryone) as Outlook._TableView;
                tableView.XML = Properties.Settings.Default.EmptyJournalViewXml;
                tableView.ShowNewItemRow = false;
                tableView.AutomaticColumnSizing = true;
                tableView.AllowInCellEditing = false;

                viewFields = tableView.ViewFields;

                // Client Id
                clientIdField = viewFields.Add("fb-clientid");
                clientIdFieldFormat = clientIdField.ColumnFormat;
                clientIdFieldFormat.Label = "Client Id";

                // Invoice Number
                invoiceNumberField = viewFields.Add("fb-invoicenumber");
                invoiceNumberFieldFormat = invoiceNumberField.ColumnFormat;
                invoiceNumberFieldFormat.Label = "Invoice Number";

                // Status
                statusField = viewFields.Add("fb-status");
                statusFieldFormat = statusField.ColumnFormat;
                statusFieldFormat.Label = "Status";

                // Date
                dateField = viewFields.Add("fb-date");
                dateFieldFormat = dateField.ColumnFormat;
                dateFieldFormat.Label = "Date";

                // PO Number
                poNumberField = viewFields.Add("fb-ponumber");
                poNumberFieldFormat = poNumberField.ColumnFormat;
                poNumberFieldFormat.Label = "PO Number";

                // Terms
                termsField = viewFields.Add("fb-amount");
                termsFieldFormat = termsField.ColumnFormat;
                termsFieldFormat.Label = "Amount";

                //Remove unused view fields
                //  Icon
                viewFields.Remove("http://schemas.microsoft.com/mapi/proptag/0x0fff0102");


                tableView.Save();
                tableView.Apply();
            }
            finally
            {
                if (termsFieldFormat != null) Marshal.ReleaseComObject(termsFieldFormat);
                if (termsField != null) Marshal.ReleaseComObject(termsField);
                if (poNumberFieldFormat != null) Marshal.ReleaseComObject(poNumberFieldFormat);
                if (poNumberField != null) Marshal.ReleaseComObject(poNumberField);
                if (dateFieldFormat != null) Marshal.ReleaseComObject(dateFieldFormat);
                if (dateField != null) Marshal.ReleaseComObject(dateField);
                if (statusFieldFormat != null) Marshal.ReleaseComObject(statusFieldFormat);
                if (statusField != null) Marshal.ReleaseComObject(statusField);
                if (invoiceNumberFieldFormat != null) Marshal.ReleaseComObject(invoiceNumberFieldFormat);
                if (invoiceNumberField != null) Marshal.ReleaseComObject(invoiceNumberField);
                if (clientIdFieldFormat != null) Marshal.ReleaseComObject(clientIdFieldFormat);
                if (clientIdField != null) Marshal.ReleaseComObject(clientIdField);
                if (viewFields != null) Marshal.ReleaseComObject(viewFields);
                if (tableView != null) Marshal.ReleaseComObject(tableView);
                if (folderViews != null) Marshal.ReleaseComObject(folderViews);
            }
        }

        private void AddPropertyToFolder(Outlook.Folder folder, string propertyName, Outlook.OlUserPropertyType propertyType)
        {
            Outlook._UserDefinedProperties userProperties = null;
            Outlook._UserDefinedProperty userProperty = null;

            try
            {
                userProperties = folder.UserDefinedProperties;
                userProperty = userProperties.Find(propertyName);
                if (userProperty == null)
                    userProperty = userProperties.Add(propertyName, propertyType);
            }
            finally
            {
                if (userProperty != null) Marshal.ReleaseComObject(userProperty);
                if (userProperties != null) Marshal.ReleaseComObject(userProperties);
            }
        }

        private void CreateFolder(Outlook.Folder rootFolder, string folderName, Outlook.OlDefaultFolders folderType, string messageClass, string displayName, bool markAsAddressBook = false)
        {
            Outlook.Folder folder = null;
            Outlook.Folders folders = null;
            Outlook._PropertyAccessor propertyAccessor = null;

            try
            {
                folder = GetFolder(rootFolder.FolderPath + "\\" + folderName);

                if (folder == null)
                {
                    folders = rootFolder.Folders;
                    folder = folders.Add(folderName, folderType) as Outlook.Folder;
                    folder.ShowAsOutlookAB = markAsAddressBook;
                    folder.CustomViewsOnly = true;
                    propertyAccessor = folder.PropertyAccessor;
                    propertyAccessor.SetProperty("http://schemas.microsoft.com/mapi/proptag/0x36E5001F", messageClass);
                    propertyAccessor.SetProperty("http://schemas.microsoft.com/mapi/proptag/0x36E6001E", displayName);
                }
            }
            finally
            {
                if (folder != null) Marshal.ReleaseComObject(folder);
                if (propertyAccessor != null) Marshal.ReleaseComObject(propertyAccessor);
                if (folders != null) Marshal.ReleaseComObject(folders);
            }
        }

        public Outlook.Folder GetFolder(string folderPath)
        {
            Outlook._Application outlookApp = null;
            Outlook.Folder returnFolder = null;
            Outlook.Folders subFolders = null;
            Outlook.NameSpace session = null;
            Outlook.Folders sessionFolders = null;

            try
            {
                outlookApp = AddinModule.CurrentInstance.OutlookApp;
                session = outlookApp.Session;
                folderPath = folderPath.TrimStart("\\".ToCharArray());

                String[] folders = folderPath.Split("\\".ToCharArray());
                sessionFolders = session.Folders;
                returnFolder = sessionFolders[folders[0]] as Outlook.Folder;


                if (returnFolder != null)
                {
                    String folderName;
                    for (int i = 1; i < folders.Length; i++)
                    {
                        folderName = folders[i];
                        subFolders = returnFolder.Folders;
                        returnFolder = subFolders[folderName] as Outlook.Folder;
                        if (subFolders != null) Marshal.ReleaseComObject(subFolders);
                    }
                }
            }
            catch
            {
                returnFolder = null;
            }
            finally
            {
                if (sessionFolders != null) Marshal.ReleaseComObject(sessionFolders);
                if (session != null) Marshal.ReleaseComObject(session);
                if (subFolders != null) Marshal.ReleaseComObject(subFolders);
            }
            return returnFolder;
        }

        private void adxImportInvoicesRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.Explorer currExplorer = null;
            Outlook.Folder currFolder = null;
            Outlook.Items folderItems = null;
            Outlook._PropertyAccessor propertyAccessor = null;
            Outlook.JournalItem invoiceItem = null;

            try
            {
                currExplorer = OutlookApp.ActiveExplorer();
                currFolder = currExplorer.CurrentFolder as Outlook.Folder;
                folderItems = currFolder.Items;
                currFolder = currExplorer.CurrentFolder as Outlook.Folder;
                propertyAccessor = currFolder.PropertyAccessor;
                var msgClass = propertyAccessor.GetProperty("http://schemas.microsoft.com/mapi/proptag/0x36E5001F");

                if (msgClass.Equals("IPM.Journal.Freshbooks.Invoice"))
                {
                    var api = new FreshbooksApi("Your Account Name", "Your Consumer Key");
                    api.UseLegacyToken("Your User Token");

                    var invoicesRequest = new InvoicesRequest();
                    invoicesRequest.PerPage = 100;
                    var invoicesResponse = api.Invoice.List(invoicesRequest);
                    foreach (var invoice in invoicesResponse.Invoices.InvoiceList)
                    {
                        invoiceItem = folderItems.Add(Outlook.OlItemType.olJournalItem) as Outlook.JournalItem;
                        invoiceItem.Body = invoice.Number;
                        invoiceItem.SetProperty("fb-clientid", invoice.Number, Outlook.OlUserPropertyType.olNumber);
                        invoiceItem.SetProperty("fb-invoicenumber", invoice.Number, Outlook.OlUserPropertyType.olText);
                        invoiceItem.SetProperty("fb-status", invoice.Status, Outlook.OlUserPropertyType.olText);
                        invoiceItem.SetProperty("fb-ponumber", invoice.PoNumber, Outlook.OlUserPropertyType.olText);
                        invoiceItem.SetProperty("fb-amount", invoice.Amount, Outlook.OlUserPropertyType.olCurrency);
                        invoiceItem.SetProperty("fb-date", invoice.Date, Outlook.OlUserPropertyType.olDateTime);
                        invoiceItem.Save();
                    }
                }

            }
            finally
            {
                if (invoiceItem != null) Marshal.ReleaseComObject(invoiceItem);
                if (propertyAccessor != null) Marshal.ReleaseComObject(propertyAccessor);
                if (folderItems != null) Marshal.ReleaseComObject(folderItems);
                if (currFolder != null) Marshal.ReleaseComObject(currFolder);
                if (currExplorer != null) Marshal.ReleaseComObject(currExplorer);
            }
        }

        private void adxImportProjectsRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.Explorer currExplorer = null;
            Outlook.Folder currFolder = null;
            Outlook.Items folderItems = null;
            Outlook._PropertyAccessor propertyAccessor = null;
            Outlook.ContactItem projectItem = null;

            try
            {
                currExplorer = OutlookApp.ActiveExplorer();
                currFolder = currExplorer.CurrentFolder as Outlook.Folder;
                folderItems = currFolder.Items;
                currFolder = currExplorer.CurrentFolder as Outlook.Folder;
                propertyAccessor = currFolder.PropertyAccessor;
                var msgClass = propertyAccessor.GetProperty("http://schemas.microsoft.com/mapi/proptag/0x36E5001F");

                if (msgClass.Equals("IPM.Contact.Freshbooks.Project"))
                {
                    var api = new FreshbooksApi("account", "consumerkey");
                    api.UseLegacyToken("token");

                    var projectsRequest = new ProjectsRequest();
                    projectsRequest.PerPage = 100;
                    var projectsResponse = api.Project.List(projectsRequest);
                    foreach (var project in projectsResponse.Projects.ProjectList)
                    {
                        projectItem = folderItems.Add(Outlook.OlItemType.olContactItem) as Outlook.ContactItem;
                        projectItem.MessageClass = "IPM.Contact.Freshbooks.Project";
                        projectItem.FullName = project.Name;
                        projectItem.SetProperty("fb-description", project.Description, Outlook.OlUserPropertyType.olText);
                        projectItem.SetProperty("fb-rate", project.Rate, Outlook.OlUserPropertyType.olCurrency);
                        projectItem.SetProperty("fb-hourbudget", project.HourBudget, Outlook.OlUserPropertyType.olCurrency);
                        projectItem.SetProperty("fb-billmethod", project.BillMethod, Outlook.OlUserPropertyType.olText);
                        projectItem.Save();
                    }
                }

            }
            finally
            {
                if (projectItem != null) Marshal.ReleaseComObject(projectItem);
                if (propertyAccessor != null) Marshal.ReleaseComObject(propertyAccessor);
                if (folderItems != null) Marshal.ReleaseComObject(folderItems);
                if (currFolder != null) Marshal.ReleaseComObject(currFolder);
                if (currExplorer != null) Marshal.ReleaseComObject(currExplorer);
            }
        }

        private void GetViewXML()
        {
            Outlook.Explorer currExplorer = null;
            Outlook.Folder currFolder = null;
            Outlook.View currView = null;

            try
            {
                currExplorer = OutlookApp.ActiveExplorer();
                currFolder = currExplorer.CurrentFolder as Outlook.Folder;

                currView = currFolder.CurrentView;
                string viewXml = currView.XML;
            }
            finally
            {
                if (currView != null) Marshal.ReleaseComObject(currView);
                if (currFolder != null) Marshal.ReleaseComObject(currFolder);
                if (currExplorer != null) Marshal.ReleaseComObject(currExplorer);
            }
        }

        private void adxOutlookEvents_InspectorActivate(object sender, object inspector, string folderName)
        {
            Outlook.Inspector currInspector = null;
            Outlook.ContactItem contact = null;
            object currItem = null;

            try
            {
                currInspector = (Outlook.Inspector)inspector;
                currItem = currInspector.CurrentItem;

                if (currItem is Outlook.ContactItem)
                {
                    contact = currItem as Outlook.ContactItem;
                    if (contact.MessageClass.Contains("IPM.Contact.Freshbooks.Project"))
                    {
                        contactInspector_ContactRibbonTab.Visible = false;
                        contactInspector_InsertRibbonTab.Visible = false;
                        contactInspector_FormatTextRibbonTab.Visible = false;
                        contactInspector_ReviewRibbonTab.Visible = false;
                        contactInspector_DeveloperRibbonTab.Visible = false;
                        contactInspector_AddinsRibbonTab.Visible = false;
                        contactInspector_BackgroundRemovalRibbonTab.Visible = false;
                    }
                    else
                    {
                        InvalidateControls();
                        contactInspector_ContactRibbonTab.Visible = true;
                        contactInspector_InsertRibbonTab.Visible = true;
                        contactInspector_FormatTextRibbonTab.Visible = true;
                        contactInspector_ReviewRibbonTab.Visible = true;
                        contactInspector_DeveloperRibbonTab.Visible = true;
                        contactInspector_AddinsRibbonTab.Visible = true;
                        contactInspector_BackgroundRemovalRibbonTab.Visible = true;
                        InvalidateControls();

                        adxProjectsInspectorRibbonTab.Visible = false;
                    }
                }
            }
            finally
            {
                if (currItem != null) Marshal.ReleaseComObject(currItem);
                if (currInspector != null) Marshal.ReleaseComObject(currInspector);
            }
        }

        private void InvalidateControls()
        {
            if (theRibbonUI != null)
            {
                theRibbonUI.InvalidateControl("adxRibbonTab_b3e50cf211904199836f12db0951c596");

                // Standard Contact Explorer Tabs
                theRibbonUI.InvalidateControl("Explorer_TaskHomeRibbonTab");
                theRibbonUI.InvalidateControl("Explorer_HomeRibbonTab_b1b0c24f21d64a2698833e0bdcd5f4f3");
                theRibbonUI.InvalidateControl("Explorer_SendReceiveRibbonTab_1f502540e12347fca75243b1d110a47c");
                theRibbonUI.InvalidateControl("Explorer_FolderRibbonTab_8073e13915c240d59a2390e9921ec3d5");
                theRibbonUI.InvalidateControl("Explorer_ViewRibbonTab_b3538d30fb984f068d76a3d3c8435ea7");
                theRibbonUI.InvalidateControl("Explorer_DeveloperRibbonTab_2a9ec8d1e6604b10acf62c20f1add267");
                theRibbonUI.InvalidateControl("Explorer_AddinsRibbonTab_de8bf649786d4405983c130c527f1079");

                //Standard Contact Inspector Tabs
                theRibbonUI.InvalidateControl("contactInspector_ContactRibbonTab_eea98e2c4ad84d2a93a05c6f5c9170dd");
                theRibbonUI.InvalidateControl("contactInspector_InsertRibbonTab_5aa0162c5a7c4c94b04e666fe7b6efa7");
                theRibbonUI.InvalidateControl("contactInspector_FormatTextRibbonTab_e7b8bd77dd864d4ba50f40f17c3a0136");
                theRibbonUI.InvalidateControl("contactInspector_ReviewRibbonTab_f348065ef6b94f028cefb902ac5fa622");
                theRibbonUI.InvalidateControl("contactInspector_DeveloperRibbonTab_db566a3b1760414a97bf6e4f8878b7e1");
                theRibbonUI.InvalidateControl("contactInspector_AddinsRibbonTab_e45f76267d5d411b8172788fed610b6a");
                theRibbonUI.InvalidateControl("contactInspector_BackgroundRemovalRibbonTab_91b3a84c83174c2bb1df63c23827287b");
                theRibbonUI.InvalidateControl("contactInspector_DealRibbonTab_68fe916c0442489b922312283a811050");
            }
        }

        private void AddinModule_OnRibbonLoaded(object sender, IRibbonUI ribbon)
        {
            theRibbonUI = ribbon;
        }

        private void adxOutlookEvents_ExplorerFolderSwitch(object sender, object explorer)
        {
            Outlook.Explorer currExplorer = null;
            Outlook.Folder folder = null;
            Outlook.Folder parentFolder = null;

            try
            {
                currExplorer = (Outlook.Explorer)explorer;
                folder = (Outlook.Folder)currExplorer.CurrentFolder;
                if (folder.Parent is Outlook.Folder)
                    parentFolder = folder.Parent as Outlook.Folder;

                bool show = !parentFolder.Name.Contains("Freshbooks");
                Explorer_HomeRibbonTab.Visible = show;
                Explorer_SendReceiveRibbonTab.Visible = show;
                Explorer_FolderRibbonTab.Visible = show;
                Explorer_ViewRibbonTab.Visible = show;
                Explorer_DeveloperRibbonTab.Visible = show;
                Explorer_AddinsRibbonTab.Visible = show;
                Explorer_TaskHomeRibbonTab.Visible = show;
                Explorer_JournalHomeRibbonTab.Visible = show;
                Explorer_MailHomeRibbonTab.Visible = show;

                if (parentFolder.Name == "Freshbooks" && folder.Name == "Projects")
                {
                    SetView(folder, "Freshbooks Projects");
                    adxFreshbooksProjectsExplorerRibbonTab.Visible = true;
                }
                else
                {
                    adxFreshbooksProjectsExplorerRibbonTab.Visible = false;
                }

                if (parentFolder.Name == "Freshbooks" && folder.Name == "Clients")
                {
                    SetView(folder, "Freshbooks Clients");
                }

                InvalidateControls();
            }
            finally
            {
                if (folder != null) Marshal.ReleaseComObject(folder);
                if (parentFolder != null) Marshal.ReleaseComObject(parentFolder);
            }
        }

        private void SetView(Outlook.Folder folder, string viewName)
        {
            Outlook.Views folderViews = null;
            Outlook.View currentView = null;
            Outlook._TableView tableView = null;

            try
            {
                folderViews = folder.Views;
                currentView = folder.CurrentView;
                if (currentView.Name != viewName)
                {
                    tableView = folderViews[viewName] as Outlook._TableView;
                    if (tableView != null) tableView.Apply();
                }
            }
            finally
            {
                if (tableView != null) Marshal.ReleaseComObject(tableView);
                if (currentView != null) Marshal.ReleaseComObject(currentView);
                if (folderViews != null) Marshal.ReleaseComObject(folderViews);
            }
        }

        private void adxImportFreshbooksProjectRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.Explorer currExplorer = null;
            Outlook.Folder currFolder = null;
            Outlook.Items folderItems = null;
            Outlook._PropertyAccessor propertyAccessor = null;
            Outlook.ContactItem projectItem = null;

            try
            {
                currExplorer = OutlookApp.ActiveExplorer();
                currFolder = currExplorer.CurrentFolder as Outlook.Folder;
                folderItems = currFolder.Items;
                currFolder = currExplorer.CurrentFolder as Outlook.Folder;
                propertyAccessor = currFolder.PropertyAccessor;
                var msgClass = propertyAccessor.GetProperty("http://schemas.microsoft.com/mapi/proptag/0x36E5001F");

                if (msgClass.Equals("IPM.Contact.Freshbooks.Project"))
                {
                    var api = new FreshbooksApi("account", "consumerkey");
                    api.UseLegacyToken("token");

                    var projectsRequest = new ProjectsRequest();
                    projectsRequest.PerPage = 100;
                    var projectsResponse = api.Project.List(projectsRequest);
                    foreach (var project in projectsResponse.Projects.ProjectList)
                    {
                        projectItem = folderItems.Add(Outlook.OlItemType.olContactItem) as Outlook.ContactItem;
                        projectItem.MessageClass = "IPM.Contact.Freshbooks.Project";
                        projectItem.FullName = project.Name;
                        projectItem.SetProperty("fb-description", project.Description, Outlook.OlUserPropertyType.olText);
                        projectItem.SetProperty("fb-rate", project.Rate, Outlook.OlUserPropertyType.olCurrency);
                        projectItem.SetProperty("fb-hourbudget", project.HourBudget, Outlook.OlUserPropertyType.olCurrency);
                        projectItem.SetProperty("fb-billmethod", project.BillMethod, Outlook.OlUserPropertyType.olText);
                        projectItem.Save();
                    }
                }

            }
            finally
            {
                if (projectItem != null) Marshal.ReleaseComObject(projectItem);
                if (propertyAccessor != null) Marshal.ReleaseComObject(propertyAccessor);
                if (folderItems != null) Marshal.ReleaseComObject(folderItems);
                if (currFolder != null) Marshal.ReleaseComObject(currFolder);
                if (currExplorer != null) Marshal.ReleaseComObject(currExplorer);
            }
        }

        private void adxNewFreshbooksPorjectRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.Explorer currExplorer = null;
            Outlook.Folder currFolder = null;
            Outlook.Items folderItems = null;
            Outlook._ContactItem contact = null;

            try
            {
                currExplorer = OutlookApp.ActiveExplorer();
                currFolder = (Outlook.Folder)currExplorer.CurrentFolder;
                folderItems = currFolder.Items;
                contact = folderItems.Add(Outlook.OlItemType.olContactItem) as Outlook._ContactItem;
                contact.MessageClass = "IPM.Contact.Freshbooks.Project";
                contact.Display();
            }
            finally
            {
                if (currFolder != null) Marshal.ReleaseComObject(currFolder);
                if (currExplorer != null) Marshal.ReleaseComObject(currExplorer);
                if (folderItems != null) Marshal.ReleaseComObject(folderItems);
                if (contact != null) Marshal.ReleaseComObject(contact);
            }
        }
    }
}

