﻿using System.Runtime.InteropServices;
using Outlook = Microsoft.Office.Interop.Outlook;
namespace Freshbooks_Addin
{
    public static class ExtensionMethods
    {
        public static void SetProperty(this Outlook.NoteItem note, string propertyName, object propertyValue, Outlook.OlUserPropertyType propertyType)
        {
            Outlook.ItemProperties itemProperties = null;
            Outlook.ItemProperty itemProperty = null;

            try
            {
                itemProperties = note.ItemProperties;
                itemProperty = itemProperties[propertyName];
                if (itemProperty != null)
                {
                    itemProperty.Value = propertyValue;
                }
                else
                {
                    itemProperty = itemProperties.Add(propertyName, propertyType, true);
                    itemProperty.Value = propertyValue;
                }
            }
            finally
            {
                if (itemProperty != null) Marshal.ReleaseComObject(itemProperty);
                if (itemProperties != null) Marshal.ReleaseComObject(itemProperties);
            }
        }

        public static void SetProperty(this Outlook.JournalItem journal, string propertyName, object propertyValue, Outlook.OlUserPropertyType propertyType)
        {
            Outlook.ItemProperties itemProperties = null;
            Outlook.ItemProperty itemProperty = null;

            try
            {
                itemProperties = journal.ItemProperties;
                itemProperty = itemProperties[propertyName];
                if (itemProperty != null)
                {
                    itemProperty.Value = propertyValue;
                }
                else
                {
                    itemProperty = itemProperties.Add(propertyName, propertyType, true);
                    itemProperty.Value = propertyValue;
                }
            }
            finally
            {
                if (itemProperty != null) Marshal.ReleaseComObject(itemProperty);
                if (itemProperties != null) Marshal.ReleaseComObject(itemProperties);
            }
        }

        public static object GetPropertyValue(this Outlook.JournalItem journal, string propertyName)
        {
            Outlook.ItemProperties itemProperties = null;
            Outlook.ItemProperty itemProperty = null;
            object returnValue = null;

            try
            {
                itemProperties = journal.ItemProperties;
                itemProperty = itemProperties[propertyName];
                if (itemProperty != null)
                {
                    returnValue = itemProperty.Value;
                    return returnValue;
                }
                return returnValue;
            }
            finally
            {
                if (itemProperty != null) Marshal.ReleaseComObject(itemProperty);
                if (itemProperties != null) Marshal.ReleaseComObject(itemProperties);
            }
        }

        public static void SetProperty(this Outlook.ContactItem contact, string propertyName, object propertyValue, Outlook.OlUserPropertyType propertyType)
        {
            Outlook.ItemProperties itemProperties = null;
            Outlook.ItemProperty itemProperty = null;

            try
            {
                itemProperties = contact.ItemProperties;
                itemProperty = itemProperties[propertyName];
                if (itemProperty != null)
                {
                    itemProperty.Value = propertyValue;
                }
                else
                {
                    itemProperty = itemProperties.Add(propertyName, propertyType, true);
                    itemProperty.Value = propertyValue;
                }
            }
            finally
            {
                if (itemProperty != null) Marshal.ReleaseComObject(itemProperty);
                if (itemProperties != null) Marshal.ReleaseComObject(itemProperties);
            }
        }

        public static object GetPropertyValue(this Outlook.ContactItem contact, string propertyName)
        {
            Outlook.ItemProperties itemProperties = null;
            Outlook.ItemProperty itemProperty = null;
            object returnValue = null;

            try
            {
                itemProperties = contact.ItemProperties;
                itemProperty = itemProperties[propertyName];
                if (itemProperty != null)
                {
                    returnValue = itemProperty.Value;
                    return returnValue;
                }
                return returnValue;
            }
            finally
            {
                if (itemProperty != null) Marshal.ReleaseComObject(itemProperty);
                if (itemProperties != null) Marshal.ReleaseComObject(itemProperties);
            }
        }

    }
}