using System;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using AddinExpress.OL;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace Freshbooks_Addin
{
    public partial class frmInvoice : AddinExpress.OL.ADXOlForm
    {
        public frmInvoice()
        {
            InitializeComponent();
        }

        private void frmInvoice_ADXAfterFormShow()
        {
            Outlook.Application outlookApp = null;
            Outlook.Inspector currInspector = null;
            Outlook.JournalItem currItem = null;

            try
            {
                outlookApp = this.OutlookAppObj as Outlook.Application;
                currInspector = outlookApp.ActiveInspector() as Outlook.Inspector;

                if (currInspector.CurrentItem is Outlook.JournalItem)
                {
                    currItem = currInspector.CurrentItem as Outlook.JournalItem;
                    txtClientId.Text = currItem.GetPropertyValue("fb-clientid").ToString();
                    txtInvoiceNumber.Text = currItem.GetPropertyValue("fb-invoicenumber").ToString();
                    txtStatus.Text = currItem.GetPropertyValue("fb-status").ToString();
                    txtPONumber.Text = currItem.GetPropertyValue("fb-ponumber").ToString();
                    txtAmount.Text = currItem.GetPropertyValue("fb-amount").ToString();
                    txtDate.Text = currItem.GetPropertyValue("fb-date").ToString();
                }

            }
            finally
            {
                if (currItem != null) Marshal.ReleaseComObject(currItem);
                if (currInspector != null) Marshal.ReleaseComObject(currInspector);
            }
        }
    }
}
